import browserSync from 'browser-sync';
import chokidar from 'chokidar';
import type { DoxicityConfig, DoxicityPublishResult, DoxicityCopyAssetsResult, DoxicityPublishOptions, DoxicityServeOptions } from './types';
export * from './types.js';
export declare const defaultConfig: DoxicityConfig;
export default class Doxicity {
    bs: browserSync.BrowserSyncInstance;
    config: DoxicityConfig;
    hasPublished: boolean;
    hasRegisteredPartials: boolean;
    watcher: chokidar.FSWatcher;
    constructor(config: Partial<DoxicityConfig>);
    private registerPartials;
    private renderPage;
    static resolve(...args: string[]): string;
    publish(options?: Partial<DoxicityPublishOptions>): Promise<DoxicityPublishResult>;
    copyAssets(): Promise<DoxicityCopyAssetsResult>;
    clean(): Promise<void>;
    serve(options: Partial<DoxicityServeOptions>): Promise<void>;
    stop(): Promise<void>;
}
