export type FilterFunction = (filename: string) => boolean;
export interface DoxicityConfig {
    source: string;
    destination: string;
    baseUrl: string;
    layouts: string;
    partials: string;
    assets: string;
    data: {
        [key: string]: unknown;
    };
    cleanBeforePublishing: boolean;
    plugins: DoxicityPlugin[];
    helpers: DoxicityHelper[];
    filterPages: FilterFunction;
    pageExtension: string;
}
export interface DoxicityHelper {
    name: string;
    callback: (args: unknown) => string;
}
export interface DoxicityPage {
    sourceFile: string;
    destinationFile: string;
    pathname: string;
    data: Record<string, unknown>;
}
export interface DoxicityPlugin {
    name: string;
    transform?: (doc: Document, page: DoxicityPage) => Document | Promise<Document>;
    afterTransform?: (html: string, page: DoxicityPage) => string | Promise<string>;
    afterAll?: (result: DoxicityPublishResult) => void | Promise<void>;
}
export interface DoxicityPublishOptions {
    copyAssets: boolean;
}
export interface DoxicityPublishResult {
    pages: DoxicityPage[];
    assets: string[];
    timeToPublish: number;
    timeToCopyAssets: number;
}
export interface DoxicityServeOptions {
    open: boolean;
    port: number;
    quiet: boolean;
    watch: boolean;
    onPublish: (result: DoxicityPublishResult) => void;
}
export interface DoxicityCopyAssetsResult {
    assets: string[];
    timeToCopy: number;
}
